# -*- coding: utf-8 -*-

filename = "values.combined.51"
filename = "values.combined.49"
filename = "values.combined.100"
values = open(filename).read().split("\n")

totalValues = {"ltp":0,"lfn":0,"lfp":0,"ltn":0,
               "ttp":0,"tfn":0,"tfp":0,"ttn":0,
               "etp":0,"efn":0,"efp":0,"etn":0,
               "ptp":0,"pfn":0,"pfp":0,"ptn":0}

countTweets = 0
for line in values:
    entries = line.split("\t")
    if entries[0] == "l": # Löschung
        totalValues["ltp"] += int(entries[1]) # True Positive
        totalValues["lfn"] += int(entries[2]) # False Negative
        totalValues["lfp"] += int(entries[3]) # False Positive
        totalValues["ltn"] += int(entries[4]) # True Negative
    elif entries[0] == "t": # Transformation
        totalValues["ttp"] += int(entries[1]) # True Positive
        totalValues["tfn"] += int(entries[2]) # False Negative
        totalValues["tfp"] += int(entries[3]) # False Positive
        totalValues["ttn"] += int(entries[4]) # True Negative   
    elif entries[0] == "e": # Einfügung
        totalValues["etp"] += int(entries[1]) # True Positive
        totalValues["efn"] += int(entries[2]) # False Negative
        totalValues["efp"] += int(entries[3]) # False Positive
        totalValues["etn"] += int(entries[4]) # True Negative       
    elif entries[0] == "p": # Punctuation / Tokenisierung
        totalValues["ptp"] += int(entries[1]) # True Positive
        totalValues["pfn"] += int(entries[2]) # False Negative
        totalValues["pfp"] += int(entries[3]) # False Positive
        totalValues["ptn"] += int(entries[4]) # True Negative 
    print line
    if line[0] == "#":   
        countTweets += 1      
           
        
ops = [("l","Löschung"),("t","Transformation"),("e","Einfügung"),("p","Tokenisierung")]
f1_all = 0      
for op,name in ops:
    print "\n"+name+":\n"
    allVal = totalValues[op+"tp"]+totalValues[op+"fn"]+totalValues[op+"fp"]+totalValues[op+"tn"]
    acc = (totalValues[op+"tp"]+totalValues[op+"tn"])/(float(allVal))
    p = totalValues[op+"tp"]/(float(totalValues[op+"tp"]+totalValues[op+"fp"]))
    r = totalValues[op+"tp"]/(float(totalValues[op+"tp"]+totalValues[op+"fn"]))
    f1 = 2*(p*r)/(float(p+r))
    print "Accuracy: " + str(acc)
    print "Precision: " + str(p)
    print "Recall: " + str(r)
    print "F1: " + str(f1)
    f1_all += f1
print "\n\nOverall F1: " + str(f1_all/4.0)
    
            