# -*- coding: utf-8 -*-

vocab_big = open("combinedVocab.vocab").read().decode("utf-8-sig").split("\n")


vocab_FeatureSet = open("combinedVocab_it_min5_featureset_big.vocab", "w")

vocabDict = {}
for line in vocab_big:
    line = line.split("\t")
    word = line[0].strip()
    count = line[0].strip()
    vocabDict[word] = count
    



#tweets = open("twita_tweets201202_01.txt").read().split("\n")



def getIGram(i,word):
    iGrammList = []
    txtLength = len(word) + 1
    maxIgramms = txtLength - i if txtLength >= i else 0
    for n in range(maxIgramms):
        iGrammList.append(word[n:n+i])
    return iGrammList    
    
    

   
def getSmilarityFeatureSetFromWord(word):
    if len(word) < 3:
        return []
    similaritySet = []
    bigrams = getIGram(2, word)
    startFeature = "$" + bigrams.pop(0)
    endFeature = bigrams.pop(-1) + "$"
    similaritySet.append(startFeature) 
    similaritySet.append(endFeature) 
    similaritySet.extend(set(bigrams))
        
    trigrams = getIGram(3, word)
    skipBigrams = []
    for trigram in trigrams:
        trigram = trigram[:1] + "|" + trigram[2:]
        skipBigrams.append(trigram)
    similaritySet.extend(set(skipBigrams))

    return similaritySet

for line in vocab_big:
    word = line.split("\t")[0].strip()
    count = line.split("\t")[1].strip()
    if len(word) > 4 and int(count) > 200:
        vocab_FeatureSet.write(word + "\t" + " ".join(getSmilarityFeatureSetFromWord(word)) + "\n")
        #print word + "\t" + " ".join(getSmilarityFeatureSetFromWord(word)) + "\n"